=== debian/changelog ===
neko (2.4.0-2) unstable; urgency=medium

  * Remove rpath.patch. Use CMAKE_SKIP_INSTALL_RPATH instead.

 -- Andy Li <andy@onthewings.net>  Sun, 18 Aug 2024 04:56:11 +0100

neko (2.4.0-1) unstable; urgency=medium

  * New upstream version.
  * Remove patches applied to upstream.
    + pcre2.patch
    + gtk3.patch
    + mbedtls3.patch
  * Add rpath.patch from upstream to avoid adding rpath to binaries.
  * Update d/copyright.
  * Remove unused unstripped-binary-or-object lintian override.

 -- Andy Li <andy@onthewings.net>  Sat, 27 Jul 2024 19:33:48 +0100

neko (2.3.0-3) unstable; urgency=medium

  * Add mbedtls3.patch from upstream (Closes: #1075869).
  * Build-Depends: pkg-config => pkgconf.
  * Bump Standards-Version to 4.7.0 (no changes).

 -- Andy Li <andy@onthewings.net>  Sat, 06 Jul 2024 21:09:37 +0100

neko (2.3.0-2) unstable; urgency=medium

  * Add pcre2.patch from upstream. (Closes: #1000057)
  * Add gtk3.patch from upstream. (Closes: #967651)
  * Bump Standards-Version to 4.6.2.0 (no changes).
  * Bump debhelper and compat level to 12 (no changes).
  * Remove hashbang from neko.bash-completion to clear lintian warning.

 -- Andy Li <andy@onthewings.net>  Wed, 05 Jul 2023 11:34:34 +0000
