=== debian/tests/control ===
Tests: neko-test
Depends: @
