## neko 2.4.1

=== libs/CMakeLists.txt ===
--- 
+++ 
@@ -35,9 +35,9 @@
 	ExternalProject_Add(Zlib
 		${EP_CONFIGS}
 		URL
-			https://zlib.net/fossils/zlib-1.2.13.tar.gz
-			https://github.com/madler/zlib/releases/download/v1.2.13/zlib-1.2.13.tar.gz
-		URL_HASH SHA256=b3a24de97a8fdbc835b9833169501030b8977031bcb54b3b3ac13740f846ab30
+			https://zlib.net/zlib-1.3.1.tar.gz
+			https://github.com/madler/zlib/releases/download/v1.3.1/zlib-1.3.1.tar.gz
+		URL_HASH SHA256=9a93b2b7dfdac77ceba5a558a580e74667dd6fede4585b91eefb60f03b72df23
 		CMAKE_ARGS ${ZLIB_CMAKE_ARGS}
 		INSTALL_COMMAND cd ${CMAKE_BINARY_DIR}/libs/src/Zlib-build &&
 			${CMAKE_COMMAND} --build . --target install --config ${config}
