=== debian/changelog ===
neko (2.4.1-1) unstable; urgency=medium

  * New upstream version.
    + Do not define bool when compiled with C23. (Closes: #1097443)
  * Bump Standards-Version to 4.7.2 (no changes).

 -- Andy Li <andy@onthewings.net>  Fri, 05 Sep 2025 01:03:15 +0000
