=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: interpreters
 Priority: optional
 Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends:
 	debhelper (>= 12~),
 	cmake,
