=== debian/watch ===
version=4
opts="uversionmangle=s/-/./g" \
 https://github.com/HaxeFoundation/neko/tags .*/archive/refs/tags/v(\d-\d-\d)\.tar\.gz
